/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 178 by dpavlin, Tue Mar 16 15:06:30 2010 UTC revision 264 by root, Sun Jun 26 15:00:40 2011 UTC
# Line 1  Line 1 
1  #!/bin/bash  #! /bin/sh
2    ### BEGIN INIT INFO
3  # based on Tony Risinger code from lxc-users  # Provides:          lxc-watchdog
4    # Required-Start:    $remote_fs $named $network $time
5    # Required-Stop:     $remote_fs $named $network
6    # Required-Start:    
7    # Required-Stop:    
8    # Default-Start:     2 3 4 5
9    # Default-Stop:      0 1 6
10    # Short-Description: Manage Linux Containers startup/shutdown
11    # Description:       Uses clever inotify hack to monitor container's
12    #                    halt/reboot events watching /var/run/utmp
13    ### END INIT INFO
14    
15    # Author: Dobrica Pavlinusic <dpavlin@rot13.org>
16    #
17    # based on Tony Risinger post to lxc-users mailing list
18  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19    #
20    # Install with:
21    # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22    # update-rc.d lxc-watchdog defaults
23    
24    
25  which inotifywait >/dev/null || apt-get install inotify-tools  which inotifywait >/dev/null || apt-get install inotify-tools
26    
 name=$1  
27    
28  if [ ! -e /var/lib/lxc/$name/config ] ; then  lxc_exists() {
29          echo "Usage: $0 name"          name=$1
30          ls /var/lib/lxc/*/config | cut -d/ -f5  
31          exit 1          if [ ! -e /var/lib/lxc/$name/config ] ; then
32  fi                  echo "Usage: $0 name"
33                    lxc_status
34                    exit 1
35            fi
36    }
37    
38    
39  rootfs=`grep lxc.rootfs /var/lib/lxc/$name/config | cut -d= -f2`  lxc_rootfs() {
40  echo "$name rootfs $rootfs"          grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41    }
42    
43    lxc_hostname() {
44            inside=`cat $(lxc_rootfs $1)/etc/hostname`
45            config=`grep lxc.utsname /var/lib/lxc/$name/config | cut -d= -f2`
46            echo "$config [$inside]";
47    }
48    
49    lxc_ip() {
50            ( grep lxc.network.ipv4 /var/lib/lxc/$name/config | grep -v '^#' | cut -d= -f2 || \
51            grep address $(lxc_rootfs $name)/etc/network/interfaces | grep -v '^#' | sed 's/.*address //' ) | \
52            head -1 | \
53            sed -e 's/ *//g' -e 's/\/.*$//'
54    }
55    
56    lxc_status() {
57            ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do
58                    boot="-"
59                    test -s /var/lib/lxc/$name/on_boot && boot="boot"
60                    echo "$name $status $boot $(lxc_rootfs $name) $(lxc_ip $name) $(lxc_hostname $name)"
61            done ) | column -t
62    }
63    
64    
65    cleanup_init_scripts() {
66            rootfs=$(lxc_rootfs $1)
67    
68            ls \
69                    $rootfs/etc/rc?.d/*checkroot* \
70                    $rootfs/etc/rc?.d/*umountfs \
71                    $rootfs/etc/rc?.d/*umountroot \
72                    $rootfs/etc/rc?.d/*hwclock* \
73                    $rootfs/etc/rc?.d/*udev* \
74                    $rootfs/etc/rc?.d/*checkfs* \
75            2>/dev/null | xargs -i rm -v {}
76    
77            echo $1 > $rootfs/etc/hostname
78            grep $1 $rootfs/etc/hosts || echo "$(lxc_ip $1) $1" >> $rootfs/etc/hosts
79    }
80    
81    
82    setup_inittab() {
83            rootfs=$(lxc_rootfs $1)
84            remove=$2
85            add=$3
86    
87            # let container respond to kill -SIGPWR
88            inittab=$rootfs/etc/inittab
89            if test -e $inittab && ! grep "$add" ${inittab} >/dev/null ; then
90                    grep -v "$remove" ${inittab} > ${inittab}.new
91                    echo $add >> ${inittab}.new
92                    mv ${inittab}.new ${inittab}
93                    echo "$inittab modified with $add"
94            fi
95    }
96    
97    
98    lxc_log() {
99            echo `date +%Y-%m-%dT%H:%M:%S` $*
100    }
101    
102    
103    lxc_kill() {
104            name=$1
105            sig=$2
106    
107            init_pid=`lxc-ps -C init -o pid | grep "^$name" | cut -d" " -f2-`
108            if [ -z "$init_pid" ] ; then
109                    lxc-info -n $name
110                    exit 1
111            fi
112            lxc_log "$name kill $sig $init_pid"
113            /bin/kill $sig $init_pid
114    }
115    
116    lxc_stop() {
117            lxc_log "$name stop"
118            lxc_kill $name -SIGPWR
119            lxc-wait -n $name -s STOPPED
120            lxc_log "$name stoped"
121    #       rm -f /var/lib/lxc/${name}/on_boot
122    }
123    
124    
125    lxc_start() {
126            name=$1
127            rootfs=$(lxc_rootfs $1)
128    
129            if [ ! -e $rootfs ] ; then
130                    echo "ERROR $name rootfs $rootfs not found"
131                    return
132            fi
133    
134  # cleanup init scripts which don't work in containers          if ! lxc-info -n $name | grep RUNNING ; then
135  ls $rootfs/etc/rc?.d/*umountfs 2>/dev/null | xargs -i rm -v {}                  lxc_log "$name start"
136  ls $rootfs/etc/rc?.d/*umountroot 2>/dev/null | xargs -i rm -v {}                  dev=`df -P $rootfs | tail -1 | cut -d" " -f1`
137  ls $rootfs/etc/rc?.d/*hwclock* 2>/dev/null | xargs -i rm -v {}                  mount $dev -o remount,rw # fix debian upgrade which remounts dir ro
138                    lxc-start -n $name -o /tmp/${name}.log -d
139                    lxc-wait  -n $name -s RUNNING
140                    lxc-info  -n $name
141                    test -f /var/lib/lxc/${name}/on_boot || echo $name > /var/lib/lxc/${name}/on_boot
142            fi
143    }
144    
145  lxc-info -n $name | grep RUNNING || lxc-start -d -n $name -o /tmp/${name}.log && echo "$name start"  lxc_watchdog() {
146    name=$1
147    rootfs=$(lxc_rootfs $1)
148    run=$rootfs/var/run
149    test -L $run && run=$rootfs/`readlink $run` # recent Debian have symlink to /run
150    cd $run || echo "can't cd watchdog into $run"
151    
152  while true; do  while true; do
153          # time of 5 minutes on it JUST IN CASE...          tasks=`wc -l < /cgroup/${name}/tasks`
154          vps_utmp=${rootfs}/var/run/utmp          stop_on=1 # init
155          inotifywait -qqt 300 ${vps_utmp}          sulogins=`lxc-ps --name $name | grep sulogin | wc -l`
156          if [ $(wc -l < /cgroup/${name}/tasks) -eq 1 ]; then          if [ "$sulogins" -gt 0 ] ; then
157                    stop_on=`expr $stop_on + $sulogins`
158            fi
159    
160            test -z "$tasks" && exit 1
161            if [ "$tasks" -eq $stop_on ]; then
162    
163                  runlevel="$(runlevel ${vps_utmp})"                  runlevel="$(runlevel utmp)"
164                  echo "# $name runlevel $runlevel"                  lxc_log "$name runlevel $runlevel"
165    
166                  case $runlevel in                  case $runlevel in
167                  N*)                  N*)
168                          # nothing for new boot state                          # nothing for new boot state
169                  ;;                  ;;
170                  ??0)                  ??0|unknown)
171                          echo "$name halt"                          lxc_log "$name halt"
172                          lxc-stop -n "${name}"                          lxc-stop -n "${name}"
173                            lxc-wait -n ${name} -s STOPPED
174                          break                          break
175                  ;;                  ;;
176                  ??6)                  ??6)
177                          echo "$name reboot";                          lxc_log "$name reboot";
178                          lxc-stop -n ${name}                          lxc-stop -n ${name}
179                          lxc-wait -n ${name} -s STOPPED                          lxc-wait -n ${name} -s STOPPED
                         mount /mnt/llin -o remount,rw  
180                          lxc-start -d -n ${name} -o /tmp/${name}.log                          lxc-start -d -n ${name} -o /tmp/${name}.log
181                  ;;                  ;;
182                  *)                  *)
# Line 54  while true; do Line 185  while true; do
185                          [ "$state" = "RUNNING" ] || break                          [ "$state" = "RUNNING" ] || break
186                  ;;                  ;;
187                  esac                  esac
188            else
189                    lxc_log "$name $tasks tasks $sulogins console"
190          fi          fi
191    
192            # time of 5 minutes on it JUST IN CASE...
193            inotifywait -qqt 300 utmp
194  done  done
195    
196    lxc_log "$name watchdog exited"
197    
198    }
199    
200    
201    usage() {
202            echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
203            exit 3
204    }
205    
206    command_on_lxc() {
207    command=$1
208    shift
209    
210    echo "# $command $1"
211    
212    case "$command" in
213    
214    start)
215            lxc_exists $1
216            cleanup_init_scripts $1
217            setup_inittab $1 ":respawn:/sbin/getty.*tty1"   "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
218            setup_inittab $1 "::power"                      "p0::powerfail:/sbin/init 0"
219            setup_inittab $1 "::ctrlaltdel"                 "p6::ctrlaltdel:/sbin/init 6"
220            lxc_start $1
221            # give container 5 seconds to start more than one process
222            ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
223            ;;
224    stop|halt)
225            lxc_exists $1
226            lxc_stop $1
227            ;;
228    reload|force-reload|restart|reboot)
229            lxc_kill $1 -SIGINT
230            ;;
231    watchdog)
232            lxc_watchdog $1
233            ;;
234    boot)
235            echo $1 > /var/lib/lxc/$1/on_boot
236            ;;
237    disable)
238            echo -n > /var/lib/lxc/$1/on_boot
239            ;;
240    *)
241            usage
242            ;;
243    
244    esac
245    
246    }
247    
248    command=$1
249    test -z "$command" && usage
250    test "$command" = "status" && lxc_status && exit
251    shift
252    
253    if [ -z "$1" ] ; then
254            ls /var/lib/lxc/*/on_boot | while read path ; do
255                    name=`echo $path | cut -d/ -f5`
256                    if [ "$command" != "start" -o "$command" = "start" -a -s $path ] ; then
257                            command_on_lxc $command $name
258                    else
259                            echo "# skip $command $name"
260                    fi
261            done
262    else
263            while [ ! -z "$1" ] ; do
264                    command_on_lxc $command $1
265                    shift
266            done
267    fi
268    

Legend:
Removed from v.178  
changed lines
  Added in v.264

  ViewVC Help
Powered by ViewVC 1.1.26